/*
 Dieser void benoetigt UNBEDINGT zwei GLOBALE Variablen, welche die aktuelle X-Position und Y-Position wiedergeben.
 Diese Variablen müssenn ENTWEDER 'int XA' und 'int YA' heissen,
 ODER die Namen müssen entsprechend in diesem Programmcode geaendert werden.
 ES WERDEN AUSSERDEM GLOBAL BENOETIGT:
 -die Variable 'int schnell'. Sie gibt den Grunddelay der Stepper an und sollte etwa auf 1000 gesetzt werden.
 -die Variable 'int xPinAction', ueber welche der X-Richtungstepper gesteuert wird.
 -die Variable 'int xPinRichtung', welche angibt ob die Geschwindigkeit in X-Richtung positiv oder negativ ist.
 -die Variable 'int yPinAction', ueber welche der Y-Richtungstepper gesteuert wird.
 -die Variable 'int yPinRichtung', welche angibt ob die Geschwindigkeit in Y-Richtung positiv oder negativ ist.
 -die Variable 'int Pixel'. Diese gibt das Verhaeltnis an, wieviele Steps einem Pixel entsprechen sollen (106 Steps == 1cm).
 
 Der Befehl laesst die Stepper auf kuerzestem Weg (also als Linie) von der aktuellen Position aus die angegeben Koordinaten ansteuern.
 Das Resultat ist stufenlos.
*/

//Grunddelay:
int schnell = 1000;
//X-Richtungstepper:
int xPinAction = 3;
int xPinRichtung = 2;
//Y-Richtungstepper:
int yPinAction = 5;
int yPinRichtung = 4;
//Pixel-Step-Verhaeltnis:
int Pixel = 106;
//Variablen der aktuellen Position:
int XA = 0;
int YA = 0;

//Hier koennte ein Programm folgen:
void setup(){}
void loop(){}


/*************************************************makeLineTo-BEFEHL************************************************/
void makeLineTo(int x1, int y1) {

  float strecke_X = x1 - XA;  //gibt die Strecke in X-Richtung an. Die Strecke ist die EINGEGEBENE Koordinate MINUS die AKTUELLE Koordniate.
  float strecke_Y = y1 - YA;  //gibt die Strecke in Y-Richtung an.
  float Intervall_X;  //gibt das Intervall an, in dem das Signal fuer den Stepper zwischen HIGH und LOW und umgekehrt wechselt (X-Richtung).
  float Intervall_Y;  //gibt das Intervall an, in dem das Signal fuer den Stepper zwischen HIGH und LOW und umgekehrt wechselt (Y-Richtung).


  if (strecke_X < 0) {
    digitalWrite(xPinRichtung, LOW);  //Als NEGATIVE Richtung wird der Wert LOW festgelegt. Die Richtung ist negativ, wenn die Strecke negativ ist. 
    strecke_X = strecke_X * (-1); //Betrag der negativen Strecke
  }
  else {
    digitalWrite(xPinRichtung, HIGH); //Als POSITIVE Richtung wird der Wert HIGH festgelegt.
  }

  if (strecke_Y < 0) {
    digitalWrite(yPinRichtung, LOW);
    strecke_Y = strecke_Y * (-1);
  }
  else {
    digitalWrite(yPinRichtung, HIGH);
  }

  if (strecke_X > strecke_Y) {
    Intervall_X = schnell * (strecke_Y / strecke_X);  //Berechnung des Verhaeltnisses in dem die Stepper zwischen HIGH und LOW wechseln
    Intervall_Y = schnell;
  }
  else {
    Intervall_Y = schnell * (strecke_X / strecke_Y);
    Intervall_X = schnell;
  }

  unsigned long zeit_vorher_X = 0;  //Die Zeit, zu der der Stepper zum letzten mal zwischen HIGH und LOW gewechselt hat
  bool modus_X = false; //Zustand, zeigt ob HIGH (==true) oder LOW (==false)
  unsigned long zeit_vorher_Y = 0;
  bool modus_Y = false;
  int zaehlerX = 0; //zaehlen, wie viele Steps die Stepper gemacht haben
  int zaehlerY = 0;

  unsigned long Zeit_aktuell = micros();  //zaehlt die Microsekunden seit dem Start des Programmes
  zeit_vorher_X = Zeit_aktuell;
  zeit_vorher_Y = Zeit_aktuell;

  while (zaehlerX < strecke_X * Pixel || zaehlerY < strecke_Y * Pixel) {
    Zeit_aktuell = micros();

    if (Zeit_aktuell - zeit_vorher_X >= Intervall_X) {
      zeit_vorher_X = Zeit_aktuell;
      
      if (modus_X == false) {
        digitalWrite(xPinAction, HIGH);
        modus_X = true;
      }

      else {
        digitalWrite(xPinAction, LOW);
        modus_X = false;
        zaehlerX++;
      }
    }

    if (Zeit_aktuell - zeit_vorher_Y >= Intervall_Y) {
      zeit_vorher_Y = Zeit_aktuell;
      
      if (modus_Y == false) {
        digitalWrite(yPinAction, HIGH);
        modus_Y = true;
      }
      else {
        digitalWrite(yPinAction, LOW);
        modus_Y = false;
        zaehlerY++;
      }
    }



  }

  XA = x1;
  YA = y1;
}
